#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_MAX_DRIVER_NAME_SIZE_KHR")]
pub const MAX_DRIVER_NAME_SIZE_KHR: u32 = 256;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_MAX_DRIVER_INFO_SIZE_KHR")]
pub const MAX_DRIVER_INFO_SIZE_KHR: u32 = 256;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DRIVER_PROPERTIES_SPEC_VERSION")]
pub const KHR_DRIVER_PROPERTIES_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DRIVER_PROPERTIES_EXTENSION_NAME")]
pub const KHR_DRIVER_PROPERTIES_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_driver_properties");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDriverIdKHR.html)) · Alias <br/> VkDriverId - Khronos driver IDs\n[](#_c_specification)C Specification\n----------\n\nKhronos driver IDs which **may** be returned in[`crate::vk::PhysicalDeviceDriverProperties::driver_id`] are:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef enum VkDriverId {\n    VK_DRIVER_ID_AMD_PROPRIETARY = 1,\n    VK_DRIVER_ID_AMD_OPEN_SOURCE = 2,\n    VK_DRIVER_ID_MESA_RADV = 3,\n    VK_DRIVER_ID_NVIDIA_PROPRIETARY = 4,\n    VK_DRIVER_ID_INTEL_PROPRIETARY_WINDOWS = 5,\n    VK_DRIVER_ID_INTEL_OPEN_SOURCE_MESA = 6,\n    VK_DRIVER_ID_IMAGINATION_PROPRIETARY = 7,\n    VK_DRIVER_ID_QUALCOMM_PROPRIETARY = 8,\n    VK_DRIVER_ID_ARM_PROPRIETARY = 9,\n    VK_DRIVER_ID_GOOGLE_SWIFTSHADER = 10,\n    VK_DRIVER_ID_GGP_PROPRIETARY = 11,\n    VK_DRIVER_ID_BROADCOM_PROPRIETARY = 12,\n    VK_DRIVER_ID_MESA_LLVMPIPE = 13,\n    VK_DRIVER_ID_MOLTENVK = 14,\n    VK_DRIVER_ID_COREAVI_PROPRIETARY = 15,\n    VK_DRIVER_ID_JUICE_PROPRIETARY = 16,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_AMD_PROPRIETARY_KHR = VK_DRIVER_ID_AMD_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_AMD_OPEN_SOURCE_KHR = VK_DRIVER_ID_AMD_OPEN_SOURCE,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_MESA_RADV_KHR = VK_DRIVER_ID_MESA_RADV,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_NVIDIA_PROPRIETARY_KHR = VK_DRIVER_ID_NVIDIA_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_INTEL_PROPRIETARY_WINDOWS_KHR = VK_DRIVER_ID_INTEL_PROPRIETARY_WINDOWS,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_INTEL_OPEN_SOURCE_MESA_KHR = VK_DRIVER_ID_INTEL_OPEN_SOURCE_MESA,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_IMAGINATION_PROPRIETARY_KHR = VK_DRIVER_ID_IMAGINATION_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_QUALCOMM_PROPRIETARY_KHR = VK_DRIVER_ID_QUALCOMM_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_ARM_PROPRIETARY_KHR = VK_DRIVER_ID_ARM_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_GOOGLE_SWIFTSHADER_KHR = VK_DRIVER_ID_GOOGLE_SWIFTSHADER,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_GGP_PROPRIETARY_KHR = VK_DRIVER_ID_GGP_PROPRIETARY,\n  // Provided by VK_KHR_driver_properties\n    VK_DRIVER_ID_BROADCOM_PROPRIETARY_KHR = VK_DRIVER_ID_BROADCOM_PROPRIETARY,\n} VkDriverId;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_driver_properties\ntypedef VkDriverId VkDriverIdKHR;\n```\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>Khronos driver IDs may be allocated by vendors at any time.<br/>There may be multiple driver IDs for the same vendor, representing different<br/>drivers (for e.g. different platforms, proprietary or open source, etc.).<br/>Only the latest canonical versions of this Specification, of the<br/>corresponding `vk.xml` API Registry, and of the corresponding`vulkan_core.h` header file **must** contain all reserved Khronos driver IDs.<br/><br/>Only driver IDs registered with Khronos are given symbolic names.<br/>There **may** be unregistered driver IDs returned.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDeviceDriverProperties`], [`crate::vk::PhysicalDeviceVulkan12Properties`]\n"]
#[doc(alias = "VkDriverIdKHR")]
#[allow(non_camel_case_types)]
pub type DriverIdKHR = crate::vk1_2::DriverId;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkConformanceVersionKHR.html)) · Alias <br/> VkConformanceVersion - Structure containing the conformance test suite version the implementation is compliant with\n[](#_c_specification)C Specification\n----------\n\nThe conformance test suite version an implementation is compliant with is\ndescribed with the [`crate::vk::ConformanceVersion`] structure:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkConformanceVersion {\n    uint8_t    major;\n    uint8_t    minor;\n    uint8_t    subminor;\n    uint8_t    patch;\n} VkConformanceVersion;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_driver_properties\ntypedef VkConformanceVersion VkConformanceVersionKHR;\n```\n[](#_members)Members\n----------\n\n* `major` is the major version number of the conformance test suite.\n\n* `minor` is the minor version number of the conformance test suite.\n\n* `subminor` is the subminor version number of the conformance test\n  suite.\n\n* `patch` is the patch version number of the conformance test suite.\n[](#_description)Description\n----------\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDeviceDriverProperties`], [`crate::vk::PhysicalDeviceVulkan12Properties`]\n"]
#[doc(alias = "VkConformanceVersionKHR")]
#[allow(non_camel_case_types)]
pub type ConformanceVersionKHR = crate::vk1_2::ConformanceVersion;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkConformanceVersionKHR.html)) · Alias <br/> VkConformanceVersion - Structure containing the conformance test suite version the implementation is compliant with\n[](#_c_specification)C Specification\n----------\n\nThe conformance test suite version an implementation is compliant with is\ndescribed with the [`crate::vk::ConformanceVersion`] structure:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkConformanceVersion {\n    uint8_t    major;\n    uint8_t    minor;\n    uint8_t    subminor;\n    uint8_t    patch;\n} VkConformanceVersion;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_driver_properties\ntypedef VkConformanceVersion VkConformanceVersionKHR;\n```\n[](#_members)Members\n----------\n\n* `major` is the major version number of the conformance test suite.\n\n* `minor` is the minor version number of the conformance test suite.\n\n* `subminor` is the subminor version number of the conformance test\n  suite.\n\n* `patch` is the patch version number of the conformance test suite.\n[](#_description)Description\n----------\n[](#_see_also)See Also\n----------\n\n[`crate::vk::PhysicalDeviceDriverProperties`], [`crate::vk::PhysicalDeviceVulkan12Properties`]\n"]
#[doc(alias = "VkConformanceVersionKHR")]
#[allow(non_camel_case_types)]
pub type ConformanceVersionKHRBuilder<'a> = crate::vk1_2::ConformanceVersionBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceDriverPropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceDriverProperties - Structure containing driver identification information\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceDriverProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceDriverProperties {\n    VkStructureType         sType;\n    void*                   pNext;\n    VkDriverId              driverID;\n    char                    driverName[VK_MAX_DRIVER_NAME_SIZE];\n    char                    driverInfo[VK_MAX_DRIVER_INFO_SIZE];\n    VkConformanceVersion    conformanceVersion;\n} VkPhysicalDeviceDriverProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_driver_properties\ntypedef VkPhysicalDeviceDriverProperties VkPhysicalDeviceDriverPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* `driverID` is a unique identifier for the driver of the physical\n  device.\n\n* `driverName` is an array of [`crate::vk::MAX_DRIVER_NAME_SIZE`] `char`containing a null-terminated UTF-8 string which is the name of the\n  driver.\n\n* `driverInfo` is an array of [`crate::vk::MAX_DRIVER_INFO_SIZE`] `char`containing a null-terminated UTF-8 string with additional information\n  about the driver.\n\n* `conformanceVersion` is the version of the Vulkan conformance test\n  this driver is conformant against (see [`crate::vk::ConformanceVersion`]).\n\nIf the [`crate::vk::PhysicalDeviceDriverProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nThese are properties of the driver corresponding to a physical device.\n\n`driverID` **must** be immutable for a given driver across instances,\nprocesses, driver versions, and system reboots.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceDriverProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_DRIVER_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ConformanceVersion`], [`crate::vk::DriverId`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceDriverPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceDriverPropertiesKHR = crate::vk1_2::PhysicalDeviceDriverProperties;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceDriverPropertiesKHR.html)) · Alias <br/> VkPhysicalDeviceDriverProperties - Structure containing driver identification information\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceDriverProperties`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceDriverProperties {\n    VkStructureType         sType;\n    void*                   pNext;\n    VkDriverId              driverID;\n    char                    driverName[VK_MAX_DRIVER_NAME_SIZE];\n    char                    driverInfo[VK_MAX_DRIVER_INFO_SIZE];\n    VkConformanceVersion    conformanceVersion;\n} VkPhysicalDeviceDriverProperties;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_driver_properties\ntypedef VkPhysicalDeviceDriverProperties VkPhysicalDeviceDriverPropertiesKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n[](#_description)Description\n----------\n\n* `driverID` is a unique identifier for the driver of the physical\n  device.\n\n* `driverName` is an array of [`crate::vk::MAX_DRIVER_NAME_SIZE`] `char`containing a null-terminated UTF-8 string which is the name of the\n  driver.\n\n* `driverInfo` is an array of [`crate::vk::MAX_DRIVER_INFO_SIZE`] `char`containing a null-terminated UTF-8 string with additional information\n  about the driver.\n\n* `conformanceVersion` is the version of the Vulkan conformance test\n  this driver is conformant against (see [`crate::vk::ConformanceVersion`]).\n\nIf the [`crate::vk::PhysicalDeviceDriverProperties`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceProperties2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceProperties2`], it is filled in with each\ncorresponding implementation-dependent property.\n\nThese are properties of the driver corresponding to a physical device.\n\n`driverID` **must** be immutable for a given driver across instances,\nprocesses, driver versions, and system reboots.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceDriverProperties-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_DRIVER_PROPERTIES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ConformanceVersion`], [`crate::vk::DriverId`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceDriverPropertiesKHR")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceDriverPropertiesKHRBuilder<'a> = crate::vk1_2::PhysicalDeviceDriverPropertiesBuilder<'a>;
#[doc = "Provided by [`crate::extensions::khr_driver_properties`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_DRIVER_PROPERTIES_KHR: Self = Self::PHYSICAL_DEVICE_DRIVER_PROPERTIES;
}
#[doc = "Provided by [`crate::extensions::khr_driver_properties`]"]
impl crate::vk1_2::DriverId {
    pub const AMD_PROPRIETARY_KHR: Self = Self::AMD_PROPRIETARY;
    pub const AMD_OPEN_SOURCE_KHR: Self = Self::AMD_OPEN_SOURCE;
    pub const MESA_RADV_KHR: Self = Self::MESA_RADV;
    pub const NVIDIA_PROPRIETARY_KHR: Self = Self::NVIDIA_PROPRIETARY;
    pub const INTEL_PROPRIETARY_WINDOWS_KHR: Self = Self::INTEL_PROPRIETARY_WINDOWS;
    pub const INTEL_OPEN_SOURCE_MESA_KHR: Self = Self::INTEL_OPEN_SOURCE_MESA;
    pub const IMAGINATION_PROPRIETARY_KHR: Self = Self::IMAGINATION_PROPRIETARY;
    pub const QUALCOMM_PROPRIETARY_KHR: Self = Self::QUALCOMM_PROPRIETARY;
    pub const ARM_PROPRIETARY_KHR: Self = Self::ARM_PROPRIETARY;
    pub const GOOGLE_SWIFTSHADER_KHR: Self = Self::GOOGLE_SWIFTSHADER;
    pub const GGP_PROPRIETARY_KHR: Self = Self::GGP_PROPRIETARY;
    pub const BROADCOM_PROPRIETARY_KHR: Self = Self::BROADCOM_PROPRIETARY;
}
